layers = iface.mapCanvas().layers()
for layer in layers:
    if layer.name() == "accidents":
        accident_layer = layer
    if layer.name() == "OSMnodes":
        node_layer = layer
junction_threshold = 20 #metres
nodes = {}
for accident in accident_layer.getFeatures():    
    nearest_neighbour_ID = 0
    nearest_neighbour_distance = 1000000
    for node in node_layer.getFeatures():
        dist = accident.geometry().distance(node.geometry())
        if dist < nearest_neighbour_distance:
            nearest_neighbour_distance = dist
            nearest_neighbour_ID = node['osmid']
    if nearest_neighbour_distance < junction_threshold:
        #this accident is near to a junction
        if not nearest_neighbour_ID in nodes:
            nodes[nearest_neighbour_ID] = 1
        else:
            nodes[nearest_neighbour_ID] += 1
for osmid, total in nodes.items():
    print (osmid, total)
biggest_node = max(nodes, key=nodes.get)
print ("most dangerous ", biggest_node, nodes[biggest_node])
sql = "\"osmid\" = " + "'"  + biggest_node + "'"
print (sql)
feats = node_layer.getFeatures( QgsFeatureRequest().setFilterExpression ( sql ) )
node_layer.selectByIds( [ f.id() for f in feats ] )
box = node_layer.boundingBoxOfSelected()
iface.mapCanvas().setExtent(box)
iface.mapCanvas().refresh()
